import fs from "node:fs/promises";
import { EOL } from "node:os";
import { readFileSafe } from "../shared/readFileSafe.js";
const endOfReadmeNotice = [
  ``,
  `<!-- You can remove this notice if you don't want it \u{1F642} no worries! -->`,
  ``,
  `> \u{1F499} This package was templated with [create-typescript-app](https://github.com/JoshuaKGoldberg/create-typescript-app).`,
  ``
].join(EOL);
const endOfReadmeMatcher = /💙.+(?:based|built|templated).+(?:from|using|on|with).+create-typescript-app/;
async function updateReadme() {
  const contents = await readFileSafe("./README.md", "");
  if (!endOfReadmeMatcher.test(contents)) {
    await fs.appendFile("./README.md", endOfReadmeNotice);
  }
}
export {
  endOfReadmeMatcher,
  endOfReadmeNotice,
  updateReadme
};
//# sourceMappingURL=updateReadme.js.map