import { formatYaml } from "../formatters/formatYaml.js";
function createWorkflowFile({
  concurrency,
  name,
  on = {
    pull_request: null,
    push: {
      branches: ["main"]
    }
  },
  permissions,
  ...options
}) {
  return formatYaml({
    concurrency,
    jobs: {
      [name.replaceAll(" ", "_").toLowerCase()]: {
        "runs-on": "ubuntu-latest",
        steps: "runs" in options ? [
          { uses: "actions/checkout@v4" },
          { uses: "./.github/actions/prepare" },
          ...options.runs.map((run) => ({ run }))
        ] : options.steps
      }
    },
    name,
    on,
    permissions
  }).replaceAll(/\n(\S)/g, "\n\n$1").replaceAll(/: "\\n(.+)"/g, ": |\n$1").replaceAll("\\n", "\n").replaceAll("\\t", "  ");
}
export {
  createWorkflowFile
};
//# sourceMappingURL=createWorkflowFile.js.map