import { readFileSafeAsJson } from "../../../shared/readFileSafeAsJson.js";
import { formatJson } from "./formatters/formatJson.js";
async function writeAllContributorsRC(options) {
  const existing = await readFileSafeAsJson(
    ".all-contributorsrc"
  );
  return await formatJson({
    badgeTemplate: '	<a href="#contributors" target="_blank"><img alt="All Contributors: <%= contributors.length %> \u{1F46A}" src="https://img.shields.io/badge/all_contributors-<%= contributors.length %>_\u{1F46A}-21bb42.svg" /></a>',
    commit: false,
    commitConvention: "angular",
    contributors: existing?.contributors ?? [],
    contributorsPerLine: 7,
    contributorsSortAlphabetically: true,
    files: ["README.md"],
    imageSize: 100,
    projectName: options.repository,
    projectOwner: options.owner,
    repoHost: "https://github.com",
    repoType: "github"
  });
}
export {
  writeAllContributorsRC
};
//# sourceMappingURL=writeAllContributorsRC.js.map